# algorand_kmd (EXPERIMENTAL)
API for KMD (Key Management Daemon)

This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.0.1
- Build package: org.openapitools.codegen.languages.DartDioNextClientCodegen

## Requirements

* Dart 2.12.0 or later OR Flutter 1.26.0 or later
* Dio 4.0.0+

## Installation & Usage

### pub.dev
To use the package from [pub.dev](https://pub.dev), please include the following in pubspec.yaml
```yaml
dependencies:
  algorand_kmd: 1.0.0
```

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```yaml
dependencies:
  algorand_kmd:
    git:
      url: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
      #ref: main
```

### Local development
To use the package from your local drive, please include the following in pubspec.yaml
```yaml
dependencies:
  algorand_kmd:
    path: /path/to/algorand_kmd
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:algorand_kmd/algorand_kmd.dart';


final api = AlgorandKmd().getDefaultApi();
final CreateWalletRequest createWalletRequest = ; // CreateWalletRequest | 

try {
    final response = await api.createWallet(createWalletRequest);
    print(response);
} catch on DioError (e) {
    print("Exception when calling DefaultApi->createWallet: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
[*DefaultApi*](doc/DefaultApi.md) | [**createWallet**](doc/DefaultApi.md#createwallet) | **POST** /v1/wallet | Create a wallet
[*DefaultApi*](doc/DefaultApi.md) | [**deleteKey**](doc/DefaultApi.md#deletekey) | **DELETE** /v1/key | Delete a key
[*DefaultApi*](doc/DefaultApi.md) | [**deleteMultisig**](doc/DefaultApi.md#deletemultisig) | **DELETE** /v1/multisig | Delete a multisig
[*DefaultApi*](doc/DefaultApi.md) | [**exportKey**](doc/DefaultApi.md#exportkey) | **POST** /v1/key/export | Export a key
[*DefaultApi*](doc/DefaultApi.md) | [**exportMasterKey**](doc/DefaultApi.md#exportmasterkey) | **POST** /v1/master-key/export | Export the master derivation key from a wallet
[*DefaultApi*](doc/DefaultApi.md) | [**exportMultisig**](doc/DefaultApi.md#exportmultisig) | **POST** /v1/multisig/export | Export multisig address metadata
[*DefaultApi*](doc/DefaultApi.md) | [**generateKey**](doc/DefaultApi.md#generatekey) | **POST** /v1/key | Generate a key
[*DefaultApi*](doc/DefaultApi.md) | [**getVersion**](doc/DefaultApi.md#getversion) | **GET** /versions | Retrieves the current version
[*DefaultApi*](doc/DefaultApi.md) | [**getWalletInfo**](doc/DefaultApi.md#getwalletinfo) | **POST** /v1/wallet/info | Get wallet info
[*DefaultApi*](doc/DefaultApi.md) | [**importKey**](doc/DefaultApi.md#importkey) | **POST** /v1/key/import | Import a key
[*DefaultApi*](doc/DefaultApi.md) | [**importMultisig**](doc/DefaultApi.md#importmultisig) | **POST** /v1/multisig/import | Import a multisig account
[*DefaultApi*](doc/DefaultApi.md) | [**initWalletHandleToken**](doc/DefaultApi.md#initwallethandletoken) | **POST** /v1/wallet/init | Initialize a wallet handle token
[*DefaultApi*](doc/DefaultApi.md) | [**listKeysInWallet**](doc/DefaultApi.md#listkeysinwallet) | **POST** /v1/key/list | List keys in wallet
[*DefaultApi*](doc/DefaultApi.md) | [**listMultisg**](doc/DefaultApi.md#listmultisg) | **POST** /v1/multisig/list | List multisig accounts
[*DefaultApi*](doc/DefaultApi.md) | [**listWallets**](doc/DefaultApi.md#listwallets) | **GET** /v1/wallets | List wallets
[*DefaultApi*](doc/DefaultApi.md) | [**releaseWalletHandleToken**](doc/DefaultApi.md#releasewallethandletoken) | **POST** /v1/wallet/release | Release a wallet handle token
[*DefaultApi*](doc/DefaultApi.md) | [**renameWallet**](doc/DefaultApi.md#renamewallet) | **POST** /v1/wallet/rename | Rename a wallet
[*DefaultApi*](doc/DefaultApi.md) | [**renewWalletHandleToken**](doc/DefaultApi.md#renewwallethandletoken) | **POST** /v1/wallet/renew | Renew a wallet handle token
[*DefaultApi*](doc/DefaultApi.md) | [**signMultisigProgram**](doc/DefaultApi.md#signmultisigprogram) | **POST** /v1/multisig/signprogram | Sign a program for a multisig account
[*DefaultApi*](doc/DefaultApi.md) | [**signMultisigTransaction**](doc/DefaultApi.md#signmultisigtransaction) | **POST** /v1/multisig/sign | Sign a multisig transaction
[*DefaultApi*](doc/DefaultApi.md) | [**signProgram**](doc/DefaultApi.md#signprogram) | **POST** /v1/program/sign | Sign program
[*DefaultApi*](doc/DefaultApi.md) | [**signTransaction**](doc/DefaultApi.md#signtransaction) | **POST** /v1/transaction/sign | Sign a transaction
[*DefaultApi*](doc/DefaultApi.md) | [**swaggerHandler**](doc/DefaultApi.md#swaggerhandler) | **GET** /swagger.json | Gets the current swagger spec.


## Documentation For Models

 - [APIV1DELETEKeyResponse](doc/APIV1DELETEKeyResponse.md)
 - [APIV1DELETEMultisigResponse](doc/APIV1DELETEMultisigResponse.md)
 - [APIV1GETWalletsResponse](doc/APIV1GETWalletsResponse.md)
 - [APIV1POSTKeyExportResponse](doc/APIV1POSTKeyExportResponse.md)
 - [APIV1POSTKeyImportResponse](doc/APIV1POSTKeyImportResponse.md)
 - [APIV1POSTKeyListResponse](doc/APIV1POSTKeyListResponse.md)
 - [APIV1POSTKeyResponse](doc/APIV1POSTKeyResponse.md)
 - [APIV1POSTMasterKeyExportResponse](doc/APIV1POSTMasterKeyExportResponse.md)
 - [APIV1POSTMultisigExportResponse](doc/APIV1POSTMultisigExportResponse.md)
 - [APIV1POSTMultisigImportResponse](doc/APIV1POSTMultisigImportResponse.md)
 - [APIV1POSTMultisigListResponse](doc/APIV1POSTMultisigListResponse.md)
 - [APIV1POSTMultisigProgramSignResponse](doc/APIV1POSTMultisigProgramSignResponse.md)
 - [APIV1POSTMultisigTransactionSignResponse](doc/APIV1POSTMultisigTransactionSignResponse.md)
 - [APIV1POSTProgramSignResponse](doc/APIV1POSTProgramSignResponse.md)
 - [APIV1POSTTransactionSignResponse](doc/APIV1POSTTransactionSignResponse.md)
 - [APIV1POSTWalletInfoResponse](doc/APIV1POSTWalletInfoResponse.md)
 - [APIV1POSTWalletInitResponse](doc/APIV1POSTWalletInitResponse.md)
 - [APIV1POSTWalletReleaseResponse](doc/APIV1POSTWalletReleaseResponse.md)
 - [APIV1POSTWalletRenameResponse](doc/APIV1POSTWalletRenameResponse.md)
 - [APIV1POSTWalletRenewResponse](doc/APIV1POSTWalletRenewResponse.md)
 - [APIV1POSTWalletResponse](doc/APIV1POSTWalletResponse.md)
 - [APIV1Wallet](doc/APIV1Wallet.md)
 - [APIV1WalletHandle](doc/APIV1WalletHandle.md)
 - [CreateWalletRequest](doc/CreateWalletRequest.md)
 - [DeleteKeyRequest](doc/DeleteKeyRequest.md)
 - [DeleteMultisigRequest](doc/DeleteMultisigRequest.md)
 - [ExportKeyRequest](doc/ExportKeyRequest.md)
 - [ExportMasterKeyRequest](doc/ExportMasterKeyRequest.md)
 - [ExportMultisigRequest](doc/ExportMultisigRequest.md)
 - [GenerateKeyRequest](doc/GenerateKeyRequest.md)
 - [ImportKeyRequest](doc/ImportKeyRequest.md)
 - [ImportMultisigRequest](doc/ImportMultisigRequest.md)
 - [InitWalletHandleTokenRequest](doc/InitWalletHandleTokenRequest.md)
 - [ListKeysRequest](doc/ListKeysRequest.md)
 - [ListMultisigRequest](doc/ListMultisigRequest.md)
 - [MultisigSig](doc/MultisigSig.md)
 - [MultisigSubsig](doc/MultisigSubsig.md)
 - [ReleaseWalletHandleTokenRequest](doc/ReleaseWalletHandleTokenRequest.md)
 - [RenameWalletRequest](doc/RenameWalletRequest.md)
 - [RenewWalletHandleTokenRequest](doc/RenewWalletHandleTokenRequest.md)
 - [SignMultisigRequest](doc/SignMultisigRequest.md)
 - [SignProgramMultisigRequest](doc/SignProgramMultisigRequest.md)
 - [SignProgramRequest](doc/SignProgramRequest.md)
 - [SignTransactionRequest](doc/SignTransactionRequest.md)
 - [VersionsResponse](doc/VersionsResponse.md)
 - [WalletInfoRequest](doc/WalletInfoRequest.md)


## Documentation For Authorization


## api_key

- **Type**: API key
- **API key parameter name**: X-KMD-API-Token
- **Location**: HTTP header


## Author

contact@algorand.com


